﻿using System;
using System.Drawing;
using System.Windows.Forms;

namespace Auta
{
    public partial class Main_form : Form
    {
        Auto auto = new Auto();
        Timer timer = new Timer();
        byte posunuti_pruhu = 0; // o kolik, px se maji posunout pruhy
        Pen pero_cary = new Pen(Color.White, 4);
        private short skore = 0; // skore muze byt i v minusu
        private byte hustota_provozu = 4, prodleva_prekazka = 0, rychlost = 4, index_posledni_dira = 255; // rychlost = o kolik px se ma posunout vsechno za 1 tick timeru
        // posledni_dira - kdyz auto vjdede do diry, tak nez ji projede, tak probehne nekolik cyklu a neodecetlo by se 10 bodu, ale pocet cyklu krat 10. Proto si zapamatujeme index posledni diry a proto se zaznamena jen jednou viz. metoda posun. Na zacatku tam je 255 , aby to zaznamenalo i pripadnou prvni diru.
        private ushort prodleva_klakson;
        Random generator_nahodnych_cisel = new Random();
        private bool hra_byla_spustena;

        // prehravace zvuku
        System.Media.SoundPlayer prehravac_zvuku_klakson1 = new System.Media.SoundPlayer(Properties.Resources.klakson1);
        System.Media.SoundPlayer prehravac_zvuku_klakson2 = new System.Media.SoundPlayer(Properties.Resources.klakson2);
        System.Media.SoundPlayer prehravac_zvuku_klakson3 = new System.Media.SoundPlayer(Properties.Resources.klakson3);
        System.Media.SoundPlayer prehravac_zvuku_klakson4 = new System.Media.SoundPlayer(Properties.Resources.klakson4);
        System.Media.SoundPlayer prehravac_zvuku_havarie = new System.Media.SoundPlayer(Properties.Resources.havarie);

        // promenne pro prekazky
        private short[] prekazky_souradnice = { 900,900,900,900,900,900,900,900,900,900,900,900,900,900,900,900,900,900,900,900 };  // x-souradnice prekazky. vic jak 10 prekazek v jednu chvili nebude, rovnou je dat na pravy okraj. Short je proto, ze auta zajizdeji za levy okraj (do minusu)
        private byte[] prekazky_jizdni_pruh = { 255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255 }; // osmy pruh znamena, ze auto se nezobrazuje
        private byte[] prekazky_index_obrazku = new byte[20];

        // nacteme obrazky do RAMky - at je k nim rychlejsi pristup nez z resources
        private static Image ovladane_auto = Properties.Resources.auto1;
        private static Image[] prekazky_obrazek = { Properties.Resources.auto2,Properties.Resources.auto3,Properties.Resources.auto4,Properties.Resources.auto5,Properties.Resources.auto6,Properties.Resources.auto7,Properties.Resources.auto8,Properties.Resources.dira};

        AboutBox o_programu = new AboutBox();

        private short Skore
        {
            get { return skore; }
            set { skore = value; label_score.Text = value.ToString(); }
        }

        public Main_form()
        {
            InitializeComponent();

            // nastaveni pictureboxu ohen
            pictureBox_ohen.BringToFront(); // aby byl navrchu
            pictureBox_ohen.Parent = pictureBox; // aby vedel, nad cim ma byt

            // inicializace timeru
            timer.Interval = 10; // 10 ms na jeden Tick
            timer.Tick += timer_Tick;

            prodleva_klakson = Convert.ToUInt16(generator_nahodnych_cisel.Next(100,300));
        }

        // EVENTY ========================================================================================================================================================
        private void timer_Tick(object sender, EventArgs e)
        {
            // vygenerovat novou prekazku?
            if(prodleva_prekazka == 0)
            {
                nova_prekazka();
                prodleva_prekazka = Convert.ToByte(55 - (hustota_provozu * 5));
            }
            prodleva_prekazka--;

            // pustit klakson?
            if (checkBox_zvuky.Checked)
            {
                if (prodleva_klakson == 0)
                {
                    byte nahodny_klakson = Convert.ToByte(generator_nahodnych_cisel.Next(4));

                    if (nahodny_klakson == 0)
                        prehravac_zvuku_klakson1.Play();
                    else if (nahodny_klakson == 1)
                        prehravac_zvuku_klakson2.Play();
                    else if (nahodny_klakson == 2)
                        prehravac_zvuku_klakson2.Play();
                    else if (nahodny_klakson == 3)
                        prehravac_zvuku_klakson3.Play();
                    else
                        prehravac_zvuku_klakson4.Play();

                    prodleva_klakson = Convert.ToUInt16(generator_nahodnych_cisel.Next(100, 300)); // nahodne urcit, za jak dlouho se bude zase troubit
                }
                prodleva_klakson--;
            }

            posun();
        }

        private void pictureBox_Paint(object sender, PaintEventArgs e)
        {
            // VYKRESLENI CAR ===================================================================================
            for (byte pruh = 1; pruh < 7; pruh++)
            {
                for (byte cara = 0; cara < 16; cara++) // 15 car a 15 mezer. Delka cary: 30 px, delka mezery, 30 px
                {
                    e.Graphics.DrawLine(pero_cary, cara * 60 - posunuti_pruhu, pruh * 64 - 2, cara * 60 - posunuti_pruhu + 30, pruh * 64 - 2);
                }
            }

            // VYKRESLENI PREKAZEK ==============================================================================
            // nejdrive diry (aby diry nepremazavaly auta)
            for(byte index_prekazky = 0; index_prekazky < 20; index_prekazky++)
            {
                if(prekazky_jizdni_pruh[index_prekazky] != 255 && prekazky_index_obrazku[index_prekazky] == 7) // prekazka se pouziva a je to dira
                {
                    e.Graphics.DrawImage(prekazky_obrazek[prekazky_index_obrazku[index_prekazky]],prekazky_souradnice[index_prekazky],prekazky_jizdni_pruh[index_prekazky] * 64,prekazky_obrazek[prekazky_index_obrazku[index_prekazky]].Width,60);
                    //e.Graphics.DrawRectangle(Pens.Yellow, prekazky_souradnice[index_prekazky], prekazky_jizdni_pruh[index_prekazky] * 64, prekazky_obrazek[index_prekazky].Width, 60);
                    //e.Graphics.DrawString(index_prekazky.ToString(), SystemFonts.DefaultFont, Brushes.White, prekazky_souradnice[index_prekazky], prekazky_jizdni_pruh[index_prekazky] * 64);
                }
            }
            // pak auta
            for (byte index_prekazky = 0; index_prekazky < 20; index_prekazky++)
            {
                if (prekazky_jizdni_pruh[index_prekazky] != 255 && prekazky_index_obrazku[index_prekazky] != 7) // prekazka se pouziva a neni to dira
                {
                    e.Graphics.DrawImage(prekazky_obrazek[prekazky_index_obrazku[index_prekazky]], prekazky_souradnice[index_prekazky], prekazky_jizdni_pruh[index_prekazky] * 64, prekazky_obrazek[prekazky_index_obrazku[index_prekazky]].Width, 60);
                    //e.Graphics.DrawRectangle(Pens.Yellow, prekazky_souradnice[index_prekazky], prekazky_jizdni_pruh[index_prekazky] * 64, prekazky_obrazek[index_prekazky].Width, 60);
                    //e.Graphics.DrawString(index_prekazky.ToString(), SystemFonts.DefaultFont, Brushes.White, prekazky_souradnice[index_prekazky], prekazky_jizdni_pruh[index_prekazky] * 64);
                }
            }

            // VYKRESLENI AUTA ==================================================================================
            e.Graphics.DrawImage(ovladane_auto, 5, auto.jizdni_pruh * 64, ovladane_auto.Width, ovladane_auto.Height);
            // e.Graphics.DrawRectangle(Pens.Yellow,5,auto.jizdni_pruh * 64, ovladane_auto.Width, ovladane_auto.Height);
        }

        private void numericUpDown_rychlost_ValueChanged(object sender, EventArgs e)
        {
             rychlost = Convert.ToByte(numericUpDown_rychlost.Value);
        }

        protected override bool ProcessCmdKey(ref Message msg, Keys keyData)
        {
            // do switche neni potreba davat break - po prikazu return se uz nic nevykonava
            switch (keyData)
            {
                case Keys.Left:
                    auto.nahoru();
                    pictureBox.Refresh();
                    return true;
                case Keys.Right:
                    auto.dolu();
                    pictureBox.Refresh();
                    return true;
                case Keys.F1:
                    nova_hra();
                    return true;
                case Keys.Escape:
                    konec_hry();
                    return true;
                case Keys.Pause:
                    if (hra_byla_spustena) start_stop(); // funkce pause funguje jen pokud uzivatel zacal hrat (pres tlacitko F1 nebo tlacitko "Nova hra" v menu Hra
                    return true;
            }

            return base.ProcessCmdKey(ref msg, keyData);
        }

        private void btn_nova_hra_Click(object sender, EventArgs e)
        {
            nova_hra();
        }

        private void button_konec_Click(object sender, EventArgs e)
        {
            konec_hry();
        }

        private void button_o_programu_Click(object sender, EventArgs e)
        {
            o_programu.ShowDialog();
        }

        private void numericUpDown_hustota_provozu_ValueChanged(object sender, EventArgs e)
        {
            hustota_provozu = Convert.ToByte(numericUpDown_hustota_provozu.Value- 1);
        }

        private void nova_prekazka()
        {
            byte volny_index = najit_volny_index(), jizdni_pruh;

            if (volny_index != 255) // ziskali jsme volny index, pouzitelny pro novou prekazku?
            {
                jizdni_pruh = najit_volny_pruh();

                if (jizdni_pruh != 255) // je nejaky volny pruh?
                {
                    prekazky_jizdni_pruh[volny_index] = jizdni_pruh;

                    // vylosujeme predmet a prislusny obrazek ulozime do pole
                    prekazky_index_obrazku[volny_index] = Convert.ToByte(generator_nahodnych_cisel.Next(8));
                }
            }
        }

        private byte najit_volny_index()
        {
            for (byte index_prekazky = 0; index_prekazky < 20; index_prekazky++)
            {
                if (prekazky_jizdni_pruh[index_prekazky] == 255) // prekazka se nepouziva
                {
                    return index_prekazky;
                }
            }

            return 255; // pokud jsme dosli az sem, nepodarilo se najit volny index
        }

        private byte najit_volny_pruh()
        {
            byte jizdni_pruh = 255;
            bool[] testovane_jizdni_pruhy = new bool[8]; // u kazdeho pruhu si budeme pamatovat, jestli jsme ho uz testovali. Jinak by se to zacyklilo - co kdyz nebude zadny pruh volny - to by pak hledalo do nekonecna

            do
            {
                jizdni_pruh = Convert.ToByte(generator_nahodnych_cisel.Next(8));
                if (volny_pruh(jizdni_pruh)) return jizdni_pruh;
                testovane_jizdni_pruhy[jizdni_pruh] = true;
            }
            while (testovane_jizdni_pruhy[0] == false || testovane_jizdni_pruhy[1] == false || testovane_jizdni_pruhy[2] == false || testovane_jizdni_pruhy[3] == false || testovane_jizdni_pruhy[4] == false || testovane_jizdni_pruhy[5] == false || testovane_jizdni_pruhy[6] == false || testovane_jizdni_pruhy[7] == false);

            return 255; // pokud jsme dosli az sem, cyklus skoncil a nenasel se zadny volny pruh
        }

        private bool volny_pruh(byte jizdni_pruh_k_otestovani)
        {
            for (byte index_prekazky = 0; index_prekazky < 20; index_prekazky++)
            {
                if (prekazky_jizdni_pruh[index_prekazky] == jizdni_pruh_k_otestovani)
                {
                    if ((prekazky_souradnice[index_prekazky] + prekazky_obrazek[prekazky_index_obrazku[index_prekazky]].Width + 20) > 900) // za auty musi byt 10 px rozestup
                        return false;
                }
            }
            // kdyz jsme dosli az sem, nebyla nalezena zadna prekazka v ceste
            return true;
        }

        private void schovat_prekazku(byte index_prekazky)
        {
            // s obrazkem nic nedela, nedelat zbytecne veci
            prekazky_jizdni_pruh[index_prekazky] = 255; // je dano, ze kdyz ma prekazka drahu 255, znamenam to, ze neexistuje
            prekazky_souradnice[index_prekazky] = 900; // pripravit vychozi souradnici

            // prekazka dojela az na konec - pricist bod
            Skore++;
        }

        private void posun()
        {
            // posunuti silnice
            posunuti_pruhu = Convert.ToByte((posunuti_pruhu + rychlost) % 60);

            // posunuti prekazek
            for (byte index_prekazky = 0; index_prekazky < 20; index_prekazky++)
            {
                if (prekazky_jizdni_pruh[index_prekazky] != 255) // prekazka se pouziva
                {
                    if(prekazky_souradnice[index_prekazky] > -prekazky_obrazek[prekazky_index_obrazku[index_prekazky]].Width) // neni na kraji?
                    {
                        if(prekazky_index_obrazku[index_prekazky] == 7)
                            prekazky_souradnice[index_prekazky] -= rychlost;
                        else
                            prekazky_souradnice[index_prekazky] -= Convert.ToInt16(rychlost * 1.5);
                    }
                    else
                    {
                        schovat_prekazku(index_prekazky);
                    }
                }
            }
                
            // nenastala srazka?
            for (byte index_prekazky = 0; index_prekazky < 20; index_prekazky++)
            {
                if (prekazky_jizdni_pruh[index_prekazky] == auto.jizdni_pruh)
                {
                    if ((5 + ovladane_auto.Width) > (prekazky_souradnice[index_prekazky]))
                    {
                        if (prekazky_index_obrazku[index_prekazky] == 7)
                        {
                            if (index_posledni_dira != index_prekazky)
                            {
                                Skore -= 10;
                                index_posledni_dira = index_prekazky;
                                break;
                            }
                        }
                        else
                        {
                            havarie();
                            break;
                        }
                    }
                }
            }

            pictureBox.Refresh();
        }

        private void start_stop()
        {
            if(timer.Enabled)
            {
                timer.Enabled = false;
                button_pauza.Text = Properties.Resources.button_text2;
            }
            else
            {
                timer.Enabled = true;
                button_pauza.Text = Properties.Resources.button_text1;
            }
        }

        private void button_pauza_Click(object sender, EventArgs e)
        {
            start_stop();
        }

        private void nova_hra()
        {
            // vynulovani skore
            Skore = 0;

            // vraceni auta zpet do stredniho jizdniho pruhu
            auto.jizdni_pruh = 3;

            // vynulovani prekazek
            for (byte index_prekazky = 0; index_prekazky < 20; index_prekazky++)
            {
                prekazky_jizdni_pruh[index_prekazky] = 255;
                prekazky_souradnice[index_prekazky] = 900;
            }

            timer.Start();
            button_pauza.Enabled = true;
            hra_byla_spustena = true;
        }

        private void havarie()
        {
            timer.Stop();
            if(checkBox_zvuky.Checked) prehravac_zvuku_havarie.Play();

            // presunout picturebox s ohnem na dane misto a zobrazit ho
            pictureBox_ohen.Location = new Point(90, auto.jizdni_pruh * 64 - 55); // POZOR! Protoze ma tento picturebox nastaveny parent, pocita se vzdalenost od nadrazene komponenty (v tomto pripade pictureBox)
            pictureBox_ohen.Visible = true;

            if (MessageBox.Show(Properties.Resources.message1 + Skore.ToString() + '\n' + Properties.Resources.message2, Properties.Resources.title1, MessageBoxButtons.YesNo, MessageBoxIcon.Question,MessageBoxDefaultButton.Button1) == DialogResult.Yes)
            {
                pictureBox_ohen.Visible = false;
                nova_hra();
            }
            else
                Close();
        }

        private void konec_hry()
        {
            timer.Stop();
            MessageBox.Show(Properties.Resources.message3 + Skore.ToString(),Properties.Resources.title1,MessageBoxButtons.OK,MessageBoxIcon.Information);
            Close();
        }
    }
}